import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { Select } from './select';
import { SelectPopover } from './select-popover-component';
import { ItemModule } from '../item/item.module';
import { LabelModule } from '../label/label.module';
import { ListModule } from '../list/list.module';
import { RadioModule } from '../radio/radio.module';
/**
 * @hidden
 */
export class SelectModule {
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: SelectModule, providers: []
        };
    }
}
SelectModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    FormsModule,
                    ReactiveFormsModule,
                    ItemModule,
                    LabelModule,
                    ListModule,
                    RadioModule
                ],
                declarations: [
                    Select,
                    SelectPopover
                ],
                exports: [
                    Select,
                    SelectPopover
                ],
                entryComponents: [
                    SelectPopover
                ]
            },] },
];
/**
 * @nocollapse
 */
SelectModule.ctorParameters = () => [];
function SelectModule_tsickle_Closure_declarations() {
    /** @type {?} */
    SelectModule.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    SelectModule.ctorParameters;
}
//# sourceMappingURL=select.module.js.map